package jd_cookie

import (
	"context"
	"kami/api/jd_cookie/v1"
	"kami/internal/errHandler"
	"kami/internal/service"

	"github.com/gogf/gf/v2/errors/gcode"
	"github.com/gogf/gf/v2/errors/gerror"
)

// ValidateCookie 验证单个Cookie是否有效
func (c *ControllerV1) ValidateCookie(ctx context.Context, req *v1.ValidateCookieReq) (res *v1.ValidateCookieRes, err error) {
	_, err = service.SysAuth().LoginOnlyIFrame(ctx)
	if err != nil {
		err = errHandler.WrapError(ctx, gcode.CodeNotAuthorized, err, "权限不足")
		return
	}

	isValid, message, cookieId, err := service.JdCookie().ValidateCookie(ctx, req.CookieValue)
	if err != nil {
		return nil, gerror.WrapCode(gcode.CodeInternalError, err, "验证Cookie失败")
	}

	res = &v1.ValidateCookieRes{
		IsValid:  isValid,
		Message:  message,
		CookieId: cookieId,
	}
	return
}
